unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, TeeFibonacci, Series, OHLChart, CandleCh, ExtCtrls,
  TeeProcs, Chart, StdCtrls, TeCanvas, TeePenDlg, ComCtrls, TeeEdit;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    Series1: TCandleSeries;
    ChartTool1: TFibonacciTool;
    ButtonPen1: TButtonPen;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Edit2: TEdit;
    UpDown2: TUpDown;
    CheckBox1: TCheckBox;
    ChartEditor1: TChartEditor;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Chart1DblClick(Sender: TObject);
  private
    { Private declarations }
    procedure AdjusBottomAxis;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AdjusBottomAxis;
begin
  if ((ChartTool1.DrawStyle = fsFan) or
     (ChartTool1.EndX = Chart1.Axes.Bottom.Maximum)) then
    Chart1.Axes.Bottom.MaximumOffset := 25
  else
    Chart1.Axes.Bottom.MaximumOffset := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  inherited;
  Series1.FillSampleValues(40);
  ChartTool1.StartX:=Series1.DateValues[0];
  ChartTool1.StartY:=Series1.CloseValues[0];
  ChartTool1.EndX:=Series1.DateValues[10];
  ChartTool1.EndY:=Series1.CloseValues[10];
  ButtonPen1.Pen:=ChartTool1.TrendPen;
  ComboBox1.ItemIndex:=0;
  UpDown1.Position:=7;
  UpDown2.Position:=18;
  ComboBox1.Items.Add('Arcs');
  ComboBox1.Items.Add('Fans');
  ComboBox1.ItemIndex:=0;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  ChartTool1.StartX:=Series1.DateValues[UpDown1.Position];
  ChartTool1.StartY:=Series1.CloseValues[UpDown1.Position];
  AdjusBottomAxis;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  ChartTool1.EndX:=Series1.DateValues[UpDown2.Position];
  ChartTool1.EndY:=Series1.CloseValues[UpDown2.Position];
  AdjusBottomAxis;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  ChartTool1.DrawStyle:=TFibonacciStyle(ComboBox1.ItemIndex);
  AdjusBottomAxis;
end;

procedure TForm1.Chart1DblClick(Sender: TObject);
begin
  ChartEditor1.Chart:=Chart1;
  ChartEditor1.Execute;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  ChartTool1.ShowLabels:=CheckBox1.Checked;
  AdjusBottomAxis;
end;

end.
